###############################################
# Copyright 2002, 2003 Ren Serral,           #
#                      Roberto Borgione       #
# config.tcl - configuration managing script  #
#       v2.0 (04-2002)                        #
#       v2.01(02-2003)                        #
###############################################

#   This file is part of NetMeter.
#
#   NetMeter is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   NetMeter is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with NetMeter; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

###########################################################################
#              L O A D   A   C O N F I G U R A T I O N
###########################################################################
proc load_as {} \
{
   global fR
   global GlobalFileConf
   global countFL
   global countFL6

   set newfile ""
   set newfile [tk_getOpenFile -defaultextension .cfg \
       -initialdir conf/ -filetypes {{{Netmeter configuration files} {.cfg} {}}} ]

   if {$newfile == ""} {
		return
   }

   if [catch {open $newfile r} idfile] \
   {
      tk_messageBox -message "configuration file '$newfile' \n not found."
      return
   }
   set error 0
   gets $idfile line
   if [string compare "########################################"  $line] { set error 1}
   gets $idfile line
   if [string compare "#  CONFIGURATION FILE FOR NETMETER     #"  $line] { set error 1}
   gets $idfile line
   if [string compare "########################################"  $line] { set error 1}
   catch {close $idfile}
   if { $error == 1 } {
      tk_messageBox -message "configuration file '$newfile' \n invalid."
      return
   }
   #tk_messageBox -message " new file= $newfile "
   load_configuration_file $newfile
   $fR.conf.l1 configure -text "$GlobalFileConf"
}

###################################################################
#------------------------------------------------------------------
#             S A V E    A S -   C O N F I G U R A T I O N
#------------------------------------------------------------------
###################################################################
proc save_as { } \
{
   global GlobalFileConf

   set file [tk_getSaveFile -filetypes {{{Netmeter configuration files} {.cfg} {}}}\
       -initialdir conf/ -initialfile myconfig -defaultextension .cfg]
   if [string compare $file ""] {
      save_configuration_file $file
   }
}

###########################################################################
#              L O A D     C O N F I G U R A T I O N
###########################################################################
proc load_configuration_file { FileConf } \
{
   global customparams6 customEnd6 
   global customparams  customEnd
   global paramU4 pU4 countPU4 
   global paramU6 pU6 countPU6 
   global y c6lb

   global FIRST_RUN
   global ConfInfo
   global fR
   global GlobalFileConf
   global flow		;#flow array to hold flows data
   global flowLB	;#flows listbox
   global mod
   global flow6		;#flow array to hold flows data
   global flow6LB	;#flows listbox
   global mod6
   global head6
   global uni4 uni6

   global flowM		;#flow array to hold flows data
#   global flowLBM	;#flows listbox
   global modM
   global flow6M	;#flow array to hold flows data
#   global flow6LBM	;#flows listbox
   global mod6M
   global head6M
   global mul4 mul6
   
   global dly dlyM sender receiver host scenarioDir
   global ipVersion addressType

   global max_check
   global min_check
   global kill_check

   global kill
   global zoom_tgap
   global zoom_gap
   global zoom_min
   global zoom_max
   global auto_zoomx
   global zoom_size
   global zoom_sizey
   global decodepath
   global decodepath4
   global mcalcpath
   global mcalcpath4
   global npf6
   global npf

   global KeySocket
   global socksize
   global KeySource
   global ipv6SourceAddress
   global _filedatCFG

   global flagOption
   global distOption 
   global zeroOption
   global fillOption
   global backOption
   global PatternValue
   global PatternCheck

   global _xviewCMD
   global _sshCMD
   
   #Multicast related globals
   global multicast multicastEnd ;#x

   ##############################################################
   # for  LISTBOX & LIST  auto loading
   ##############################################################

   set GlobalFileConf "noname.cfg"

   #mgen 4-6  (0 params) 
   set countPU4 1
   set countPU6 1

   set countFL 0
   set countFL6 0
   set flow(number) 0
   set flow6(number) 0

   set flowM(number) 0
   set flow6M(number) 0
   
   #netperf 4-6   (1 par
   set customEnd 0
   set customEnd6 0

   if { $FIRST_RUN == 1 } \
   {
      unset  paramU4
      unset  paramU6
      set x "(parameters)"
      set paramU4($x) "0"
      set paramU6($x) "0"
      set pU4 $x
      set pU6 $x      

      set countPU4 0
      set countPU6 0
      $y    delete 0 end
      $c6lb delete 0 end
      $flowLB delete 0 end
      $flow6LB delete 0 end
#      $flowLBM delete 0 end
#      $flow6LBM delete 0 end
      $uni4.up.right.custom.lb.customLB delete 0 end
      $uni6.up.right.custom.lb.customLB delete 0 end
#      $mul4.up.right.custom.lb.customLB delete 0 end
#      $mul6.up.right.custom.lb.customLB delete 0 end
   }

	##############################################################
	### initialize data from the MAIN TCL ????? NEED ?????
	##############################################################
	set multicastEnd(ipv4) 0	;#no IPs in multicast group, at first
	set multicastEnd(ipv6) 0
	#sender:
	#init only array "sender"
	foreach i {address interface login password local} {
		foreach j {ipv4 ipv6} {
		  foreach k {unicast multicast} {
		    set sender($i,$j,$k) {}
		  }
		}
	}
	#other
	#set values for array "sender" + init others array  "receiver", "host" "scenarioDir"
	foreach i {ipv4 ipv6} {
		foreach j {unicast multicast} {
			set receiver(address,$i,$j) {}
			set sender(interface,$i,$j) eth0
			set host(address,$i,$j) {} ;#[info hostname]
			set host(interface,$i,$j) eth0
			set scenarioDir($i,$j) {}
			set sender(local,$i,$j) 0
		}
	}
	#init fields array "receiver"
	#receiver interface,..,local:
	foreach i {interface login password local} {
		foreach j {ipv4 ipv6} {
			set receiver($i,$j) {}
		}
	}

	#set values for array "receiver",
	foreach i {ipv4 ipv6} {
		set receiver(interface,$i) eth0
		set receiver(local,$i) 0
	}

   ##########################################################################
   #default value for RadioButtons (if encontred in .cfg they will be set up)
   ##########################################################################
   #page 3
   set dly(startBool)    0
   set dly(srcPortBool)  0
   set dly(startBool6)   0
   set dly(srcPortBool6) 0

   set dlyM(startBool)    0
   set dlyM(srcPortBool)  0
   set dlyM(startBool6)   0
   set dlyM(srcPortBool6) 0
   
   #page3_Advanced_distribution_plot_option
   set PatternCheck "0"
   set max_check "0"
   set min_check "0"
   set kill_check "0"
   #page 2

   set npf6(sXb) 1
   set npf6(testLength) 10
   set npf6(netserverpath)  ""
   set npf6(netperfPath)    ""
   set npf6(resultsFileNpf) "default6.npf"
   set npf6(testType) TCP_STREAM
   set npf6(tcpNodelay) 0
   set npf6(sendSocketSizeBool)  0
   set npf6(recvSocketSizeBool)  0
   set npf6(sendMessageSizeBool) 0
   set npf6(recvMessageSizeBool) 0
   set npf6(portNumberBool) 0

   set npf(sXb) 1
   set npf(testLength) ""
   set npf(netperfPath)    ""
   set npf(resultsFileNpf) "default4.npf"
   set npf(testType) TCP_STREAM
   set npf(tcpNodelay) 0
   set npf(sendSocketSizeBool)  0
   set npf(recvSocketSizeBool)  0
   set npf(sendMessageSizeBool) 0
   set npf(recvMessageSizeBool) 0
   set npf(portNumberBool) 0
   set npf(title)     "Default Netperf IPv4 Test"
   set npf6(title)    "Default Netperf IPv6 Test"

   ##########################################################################
   #default value for general variable
   ##########################################################################
   #page 1
   set ipVersion   "ipv4"
   set addressType "unicast"

   #page 3
   set  KeySource 0
   set  ipv6SourceAddress ""
   set  KeySocket 0
   set  socksize  ""

   set dly(title,ipv4)    "Default Mgen IPv4 Test"
   set dly(title,ipv6)    "Default Mgen IPv6 Test"
   set dly(mgenPath,ipv4) ""
   set dly(mgenPath,ipv6) ""
   set dly(drecPath,ipv4) ""
   set dly(drecPath,ipv6) ""
   
   set dlyM(title,ipv4)    "Default Mgen IPv4 Test"
   set dlyM(title,ipv6)    "Default Mgen IPv6 Test"
   set dlyM(mgenPath,ipv4) ""
   set dlyM(mgenPath,ipv6) ""
   set dlyM(drecPath,ipv4) ""
   set dlyM(drecPath,ipv6) ""

   set decodepath         ""
   set mcalcpath          ""

   set dly(resultsFile,ipv4) "default4.dly"
   set dly(resultsFile,ipv6) "default6.dly"

   set dlyM(resultsFile,ipv4) "default4.dly"
   set dlyM(resultsFile,ipv6) "default6.dly"
   
   if { $FIRST_RUN == 0 } \
   {
      set flagOption 1
      set distOption 0
      set fillOption 1
      set backOption 1
      set zeroOption  0
      set PatternValue 10

      set kill  25
      set zoom_min  ""
      set zoom_max  ""
      set auto_zoomx 0
      set zoom_size  480
      set zoom_sizey 460
      set zoom_gap 1
      set zoom_tgap 15
   }

   #Try to Open Configuration File
   if [catch {open $FileConf r} idfile] \
   {
      tk_messageBox -message "configuration file '$FileConf' \n not found."
      return
   }

   #Try to save Configuration File NAME
   if [catch {open  $_filedatCFG w} idfile2] {
      tk_messageBox -message  "Failed saving configuration file"
      return
   }
   set line $FileConf
   puts $idfile2 $line
   catch {close $idfile2}

   #Update Globa FileConfigDescriptor ;)
   set GlobalFileConf $FileConf

   #-------------------------------------------------------------------------
   #start to read the configuration file
   set end 0
   set wait_label 1
   set line ""
   while {$end ==0} \
   {

      if {$wait_label==1} \
      {
        gets $idfile line
        set opt 0
        if ![string compare "###START"  $line]       { }
        if ![string compare "###END"    $line]       { set end 1   }

        #page 1 data
        if ![string compare "#NetworkType" $line]    { set opt 5;  }
        if ![string compare "#sender"   $line]       { set opt 1;  }
        if ![string compare "#receiver" $line]       { set opt 2;  }
        if ![string compare "#host" $line]           { set opt 3;  }
        if ![string compare "#MainDirectory" $line]  { set opt 4;  }
        #page 1 multicast related
		if ![string compare "#multicast" $line]      { set opt 666;  } ;# 666 for taking a free number...
        #page 3 data
        if ![string compare "#StarTime"   $line]     { set opt 6;  }
        if ![string compare "#SourcePort" $line]     { set opt 7;  }
        if ![string compare "#MgenDefs"   $line]     { set opt 8;  }
        if ![string compare "#Decodepath" $line]     { set opt 9;  }
        if ![string compare "#Mcalcpath"  $line]     { set opt 10; }
        #page 2 data
        if ![string compare "#NPF6sendSocketSize"  $line] { set opt 11; }
        if ![string compare "#NPF6recvSocketSize"  $line] { set opt 12; }
        if ![string compare "#NPF6sendMessageSize" $line] { set opt 13; }
        if ![string compare "#NPF6recvMessageSize" $line] { set opt 14; }
        if ![string compare "#NPF6portNumber"      $line] { set opt 15; }
        if ![string compare "#NPF6tcpNodelay"      $line] { set npf6(tcpNodelay) 1 }
        if ![string compare "#NPF6params"          $line] { set opt 16; }

        if ![string compare "#NPF4sendSocketSize"  $line] { set opt 21; }
        if ![string compare "#NPF4recvSocketSize"  $line] { set opt 22; }
        if ![string compare "#NPF4sendMessageSize" $line] { set opt 23; }
        if ![string compare "#NPF4recvMessageSize" $line] { set opt 24; }
        if ![string compare "#NPF4portNumber"      $line] { set opt 25; }
        if ![string compare "#NPF4tcpNodelay"      $line] { set npf(tcpNodelay) 1 }
        if ![string compare "#NPF4params"          $line] { set opt 26; }
#        if ![string compare "#GRAPHprm"            $line] { set opt 27; }

        if ![string compare "#StarTime6"   $line]     { set opt 28;  }
        if ![string compare "#SourcePort6" $line]     { set opt 29;  }
        if ![string compare "#Sock6"       $line]     { set opt 30;  }
        if ![string compare "#Source6"     $line]     { set opt 31;  }
        if ![string compare "#ConfInfo"    $line]     { set opt 32;  }
        if ![string compare "#FLOW4"       $line]     { set opt 400; }
        if ![string compare "#FLOW6"       $line]     { set opt 600; }

        if ![string compare "#CustomM4"    $line]     { set opt 33;  }
        if ![string compare "#CustomM6"    $line]     { set opt 34;  }
        if ![string compare "#CustomN4"    $line]     { set opt 35;  }
        if ![string compare "#CustomN6"    $line]     { set opt 36;  }
        if ![string compare "#Xview"       $line]     { set opt 37;  }

        if {$opt != 0} { set wait_label 0 }
      } else {
#if {$FIRST_RUN==0} {
        if {$opt==33} {
            gets $idfile line
            set countPU4 $line
            for {set count 0} {$count < $countPU4} {incr count} \
            {
               gets $idfile line
               set paramU4($line) $count
            }
        }
#}
        if {$opt==37} {
            gets   $idfile line
            set _xviewCMD $line
            gets   $idfile line
            set   _sshCMD "$line -x"
        }
        if {$opt==34} {
            gets $idfile line
            set countPU6 $line
            for {set count 0} {$count < $countPU6} {incr count} \
            {
               gets $idfile line
               set paramU6($line) $count
            }
        }
        if {$opt==35} {
            gets $idfile line
            set customEnd $line
            for {set i 1} {$i<=$customEnd} {incr i} \
            {
                gets $idfile line
                set  customparams(name,$i) $line
                gets $idfile line
                set  customparams(value,$i) $line
            }
        }
        if {$opt==36} {
            gets $idfile line
            set customEnd6 $line
            for {set i 1} {$i<=$customEnd6} {incr i} \
            {
                gets $idfile line
                set  customparams6(name,$i) $line
                gets $idfile line
                set  customparams6(value,$i) $line
            }
        }
        if {$opt==32} {
            gets $idfile line
            set ConfInfo $line
        }
        if {$opt==30} {
            set  KeySocket 1
            gets $idfile line
            set socksize $line
        }
        if {$opt ==31} {
            set  KeySource 1
            gets $idfile line
            set  ipv6SourceAddress $line
        }
        if {$opt==29} {
            set dly(srcPortBool6) 1
            gets $idfile line
            set dly(srcPort6) $line
        }
        if {$opt ==28} {
            set dly(startBool6) 1
            gets $idfile line
            set dly(start6) $line
        }
        if ($opt==27) {
           gets $idfile line
           set zoom_size $line
           gets $idfile line
           set zoom_gap $line
           gets $idfile line
           set zoom_tgap $line
           gets $idfile line
           set zoom_sizey $line
        }
        if ($opt==26) {
           gets $idfile line
           set npf(sXb) $line
           gets $idfile line
           set npf(testType) $line
           gets $idfile line
           set npf(testLength) $line
           gets $idfile line
           set npf(netperfPath) $line
           gets $idfile line
           set npf(netserverpath) $line
           gets $idfile line
           set npf(resultsFileNpf) $line
           gets $idfile line
           set npf(title) $line
        }
        if ($opt==22) {
           set npf(recvSocketSizeBool) 1
           gets $idfile line
           set npf(recvSocketSize) $line
        }
        if ($opt==24) {
           set npf(recvMessageSizeBool) 1
           gets $idfile line
           set npf(recvMessageSize) $line
        }
        if ($opt==25) {
           set npf(portNumberBool) 1
           gets $idfile line
           set npf(portNumber) $line
        }
        if ($opt==23) {
           set npf(sendMessageSizeBool) 1
           gets $idfile line
           set npf(sendMessageSize) $line
        }
        if ($opt==21) {
           set npf(sendSocketSizeBool) 1
           gets $idfile line
           set npf(sendSocketSize) $line
        }
        if ($opt==16) {
           gets $idfile line
           set npf6(sXb) $line
           gets $idfile line
           set npf6(testType) $line
           gets $idfile line
           set npf6(testLength) $line
           gets $idfile line
           set npf6(netperfPath) $line
           gets $idfile line
           set npf6(netserverpath) $line
           gets $idfile line
           set npf6(resultsFileNpf) $line
           gets $idfile line
           set npf6(title) $line
        }
        if ($opt==12) {
           set npf6(recvSocketSizeBool) 1
           gets $idfile line
           set npf6(recvSocketSize) $line
        }
        if ($opt==14) {
           set npf6(recvMessageSizeBool) 1
           gets $idfile line
           set npf6(recvMessageSize) $line
        }
        if ($opt==15) {
           set npf6(portNumberBool) 1
           gets $idfile line
           set npf6(portNumber) $line
        }
        if ($opt==13) {
           set npf6(sendMessageSizeBool) 1
           gets $idfile line
           set npf6(sendMessageSize) $line
        }
        if ($opt==11) {
           set npf6(sendSocketSizeBool) 1
           gets $idfile line
           set npf6(sendSocketSize) $line
        }
        if ($opt==10) {
           gets $idfile line
           set mcalcpath $line
           gets $idfile line
           set mcalcpath4 $line
        }
        if ($opt==9) {
           gets $idfile line
           set decodepath $line
           gets $idfile line
           set decodepath4 $line
        }
        if {$opt == 8} {
           foreach j {ipv4 ipv6} {
               gets $idfile line
               set dly(mgenPath,$j) $line
               #tk_messageBox -message "$dly(mgenPath,$j) \n$line"
               gets $idfile line
               set dly(drecPath,$j) $line
               #tk_messageBox -message "$dly(drecPath,$j) \n$line"
               gets $idfile line
               set dly(resultsFile,$j) $line
               gets $idfile line
               set dly(title,$j) $line
               #tk_messageBox -message "$dly(resultsFile,$j) \n$line"
            }
        }
        if {$opt==7} {
            set dly(srcPortBool) 1
            gets $idfile line
            set dly(srcPort) $line
            #tk_messageBox -message "$dly(srcPortBool)   \n$line"
        }
        if {$opt == 6} {
            set dly(startBool) 1
            gets $idfile line
            set dly(start) $line
            #tk_messageBox -message "$dly(startBool)   \n$line"
        }
        if {$opt == 5} {
            gets $idfile line
            set  ipVersion $line
            #tk_messageBox -message "$ipVersion   \n$line"
            gets $idfile line
            set  addressType $line
            #tk_messageBox -message "$addressType \n$line"
        }
        #sender
        if {$opt == 1} \
        {
           foreach k {unicast multicast} {
             foreach j {ipv4 ipv6} {
               foreach i {address interface login local} {
                 gets $idfile line
                 set sender($i,$j,$k) $line
                 #tk_messageBox -message "$i $j $k = $sender($i,$j,$k)\n$line"
               }
             }
           }
        }
		#receiver
		if {$opt == 2} \
		{
		foreach k {unicast multicast} {
			foreach j {ipv4 ipv6} {
				gets $idfile line
				set receiver(address,$j,$k) $line
				#tk_messageBox -message "$receiver(address,$j,$k)\n$line"
			}
		}
		foreach j {ipv4 ipv6} {
			foreach i {interface login local} {
				gets $idfile line
				set receiver($i,$j) $line
				#tk_messageBox -message "$i $j $k = $receiver($i,$j)\n$line"
			}
		}
		}
		#multicast
		if {$opt == 666} \
		{
			gets $idfile ipVersion
			incr multicastEnd($ipVersion)
			gets $idfile line
			set multicast(address,$ipVersion,$multicastEnd($ipVersion)) $line
			gets $idfile line
			set multicast(login,$ipVersion,$multicastEnd($ipVersion)) $line
			gets $idfile line
			set multicast(password,$ipVersion,$multicastEnd($ipVersion)) $line
			gets $idfile line
			set multicast(interface,$ipVersion,$multicastEnd($ipVersion)) $line
			gets $idfile line
			set multicast(local,$ipVersion,$multicastEnd($ipVersion)) $line
		}    
		# End Multicast related
		if {$opt == 3} \
		{
			foreach k {unicast multicast} {
				foreach j {ipv4 ipv6} {
					foreach i {address interface} {
						gets $idfile line
						set host($i,$j,$k) $line
						#tk_messageBox -message "$i $j $k = $host($i,$j,$k)\n$line"
					}
				}
			}
		}
		if {$opt == 4} \
		{
		foreach k {unicast multicast} {
			foreach j {ipv4 ipv6} {
				gets $idfile line
				set  scenarioDir($j,$k) $line
				#tk_messageBox -message "$j $k = $scenarioDir($j,$k)\n$line"
			}
		}
		}
		##########################
		####LOAD IPV4 FLOWS#######
		##########################
		if {$opt == 400} \
		{
			incr countFL
			set flow(number) $countFL

			#tk_messageBox -message "$flow(number)"
			#Standard parameters
			gets $idfile line
			set Findex     $line 
			gets $idfile line
			set flow(start,$Findex)    $line 
			gets $idfile line
			set flow(stop,$Findex)     $line 
			gets $idfile line
			set flow(port,$Findex)     $line 
			gets $idfile line
			set flow(pattern,$Findex)  $line
			gets $idfile line
			set flow(rate,$Findex)     $line
			gets $idfile line
			set flow(size,$Findex)     $line
			gets $idfile line
			set flow(tosBool,$Findex)  $line
			gets $idfile line
			set flow(tos,$Findex)      $line
			gets $idfile line
			set flow(rsvpBool,$Findex) $line   
			gets $idfile line
			set flow(rsvp,$Findex)     $line
			gets $idfile line
			set flow(resv,$Findex)     $line
			gets $idfile line
			set flow(style,$Findex)    $line
			gets $idfile line
			set mod(number,$Findex)    $line

			for {set countFLm 1} {$countFLm <= $mod(number,$countFL)} {incr countFLm}  \
			{ 
				gets $idfile line
				set mod(start,$countFLm,$countFL)    $line 
				gets $idfile line
				set mod(pattern,$countFLm,$countFL)  $line
				gets $idfile line
				set mod(rate,$countFLm,$countFL)     $line
				gets $idfile line
				set mod(size,$countFLm,$countFL)     $line
				gets $idfile line
				set mod(tosBool,$countFLm,$countFL)  $line
				gets $idfile line
				set mod(tos,$countFLm,$countFL)      $line
				gets $idfile line
				set mod(rsvpBool,$countFLm,$countFL) $line   
				gets $idfile line
				set mod(rsvp,$countFLm,$countFL)     $line
				gets $idfile line
				set mod(resv,$countFLm,$countFL)     $line
				gets $idfile line
				set mod(style,$countFLm,$countFL)    $line
			}
			gets $idfile line
			set flow(name,$Findex)    $line
			#set flow(name,$Findex)    "+rate= +size="
		}
		##########################
		####LOAD IPV6 FLOWS#######
		##########################
		if {$opt == 600} \
		{
			incr countFL6
			set flow6(number) $countFL6
			#tk_messageBox -message "$flow6(number)"
			#Standard parameters
			gets $idfile line
			set Findex     $line 
			gets $idfile line
			set flow6(start,$Findex)    $line 
			gets $idfile line
			set flow6(stop,$Findex)     $line 
			gets $idfile line
			set flow6(port,$Findex)     $line 
			gets $idfile line
			set flow6(pattern,$Findex)  $line
			gets $idfile line
			set flow6(rate,$Findex)     $line
			gets $idfile line
			set flow6(size,$Findex)     $line
			gets $idfile line
			set flow6(tosBool,$Findex)  $line
			gets $idfile line
			set flow6(tos,$Findex)      $line
			gets $idfile line
			set mod6(number,$Findex)    $line

			###################################
			##  HEADER NOT SAVED !!!!!!
			###################################
			set  head6(number,$flow6(number)) 0
			###################################
			###################################

			for {set countFL6m 1} {$countFL6m <= $mod6(number,$countFL6)} {incr countFL6m}  \
			{ 
				gets $idfile line
				set mod6(start,$countFL6m,$countFL6)    $line 
				gets $idfile line
				set mod6(pattern,$countFL6m,$countFL6)  $line
				gets $idfile line
				set mod6(rate,$countFL6m,$countFL6)     $line
				gets $idfile line
				set mod6(size,$countFL6m,$countFL6)     $line
				gets $idfile line
				set mod6(tosBool,$countFL6m,$countFL6)    $line
				gets $idfile line
				set mod6(tos,$countFL6m,$countFL6)        $line
			}
			gets $idfile line
			set flow6(name,$Findex)    $line
			#set flow6(name,$Findex)    "rate= size="
		}
		set wait_label 1
	}
	if {[eof $idfile]} { set end 1 }
   }
#   foreach k {unicast multicast} {
#       foreach j {ipv4 ipv6} {
#            set host(address,$j,$k) [info hostname]
#     }
#   }
   catch {close $idfile}

   #finally update listbox information
   if { $FIRST_RUN == 1 } \
   {
	 destroy  $uni6.up.right.custom.b.bx
	 eval tk_optionMenu $uni6.up.right.custom.b.bx pU6 [lsort [array names paramU6 ]]
	 $uni6.up.right.custom.b.bx configure -width 20
	 pack    $uni6.up.right.custom.b.bx  -side left

	 destroy  $uni4.up.right.custom.b.bx
	 eval tk_optionMenu $uni4.up.right.custom.b.bx pU4 [lsort [array names paramU4 ]]
	 $uni4.up.right.custom.b.bx configure -width 20
	 pack    $uni4.up.right.custom.b.bx  -side left

	 for {set i 1} {$i<=$customEnd} {incr i} \
	 {
		$y insert end "$customparams(name,$i) : $customparams(value,$i)"
	 }
	 $y see end

	 for {set i 1} {$i<=$customEnd6} {incr i} \
	 {
		$c6lb insert end "$customparams6(name,$i) : $customparams6(value,$i)"
	 }
	 $c6lb see end

	 for {set countFL 1} {$countFL <= $flow6(number)} {incr countFL}  \
	 { 
		$flow6LB insert end [format "Flow  %02d  -  Mods  %02d  -  Heads  %02d  -  %s"  \
		$countFL $mod6(number,$countFL) $head6(number,$flow6(number)) $flow6(name,$countFL) ]
	 }
	 $flow6LB see end
	 for {set countFL 1} {$countFL <= $flow(number)} {incr countFL}  \
	 { 
		$flowLB insert end [format "Flow  %02d   -   Mods  %02d  -  %s" \
		$countFL $mod(number,$countFL) $flow(name,$countFL) ]
	 }          
	 $flowLB see end
	 
	 #Update the container according to the state variable
	 Select                

	 bind $flowLB <Double-1> {
		Viewflow4
	 }
	 bind $flow6LB <Double-1> {
		Viewflow6
	 }
   }          
}

###########################################################################
#              S A V E    C O N F I G U R A T I O N
###########################################################################
proc save_configuration_file { FileConf  } \
{
   global customparams6 customEnd6 
   global customparams  customEnd
   global paramU4 pU4 countPU4 
   global paramU6 pU6 countPU6 

   global ConfInfo
   global fR
   global GlobalFileConf
   global flow		;#flow array to hold flows data
   global flow6		;#flow array to hold flows data
   global flow6LB	;#flows listbox
   global mod6
   global mod
   global head6
   global mcalcpath4
   global decodepath4
   global dly sender receiver host scenarioDir
   global ipVersion addressType

   global zoom_tgap
   global zoom_gap
   global zoom_min
   global zoom_max
   global zoom_size
   global zoom_sizey
   global decodepath
   global mcalcpath
   global npf6
   global npf

   global KeySocket
   global socksize
   global KeySource
   global ipv6SourceAddress
   global _filedatCFG
   global _xviewCMD
   global _sshCMD

   # Multicast Globals
   global multicast multicastEnd   
   
   #tk_messageBox -message  "file $File"

   #Try to Save with New File NAME
   if [catch {open $FileConf w} idfile] {
     tk_messageBox -message  "Failed saving configuration file"
     return
   }

   #Try to save Configuration File NAME
   if [catch {open  $_filedatCFG w} idfile2] {
      tk_messageBox -message  "Failed saving configuration file"
      return
   }
   set line $FileConf
   puts $idfile2 $line
   catch {close $idfile2}

   #Update Globa FileConfigDescriptor ;)
   set GlobalFileConf $FileConf

   #start to write the configuration file
   set end 0
   set wait_label 1
   set line ""
   set line "########################################"
   puts $idfile $line
   set line "#  CONFIGURATION FILE FOR NETMETER     #"
   puts $idfile $line
   set line "########################################"
   puts $idfile $line
   set line "#note:  U4=Unicast IPv4 - U6=Unicast IPv6 - M4=Multicast IPv4  - M6=Multicast IPv6"
   puts $idfile $line
   set line "###START"
   puts $idfile $line
   #####################################################################
   set line "#sender:  address-interface-login-local for (Unicast IPv4 - Unicast IPv6 -  Multicast IPv4  - Multicast IPv6)"
   puts $idfile $line
   set line "#sender"
   puts $idfile $line
   foreach k {unicast multicast} {
     foreach j {ipv4 ipv6} {
        foreach i {address interface login local} {
           set line $sender($i,$j,$k)
           puts $idfile $line
        }
     }
   }
   set line "#receiver:  address for (U4 - U6 -  M4  - M6)  interface-login-local  for (U4 - U6 )"
   puts $idfile $line
   set line "#receiver"
   puts $idfile $line
   foreach k {unicast multicast} {
      foreach j {ipv4 ipv6} {
         set line $receiver(address,$j,$k)
         puts $idfile $line
      }
   }
   foreach j {ipv4 ipv6} {
      foreach i {interface login local} {
         set line $receiver($i,$j)
         puts $idfile $line
      }
   }
   # Multicast related stuff
	set line "#multicast:  address for (M4  - M6)  interface-login-local  for (U4 - U6 )"
	puts $idfile $line
	foreach j {ipv4 ipv6} {
		if {$multicastEnd($j) > 0} {
			for {set actual 1} {$actual <= $multicastEnd($j)} {incr actual} {
				set line "#multicast"
				puts $idfile $line
				set line $j
				puts $idfile $line
				set line $multicast(address,$j,$actual)
				puts $idfile $line
				set line $multicast(login,$j,$actual)
				puts $idfile $line
				set line $multicast(password,$j,$actual)
				puts $idfile $line
				set line $multicast(interface,$j,$actual)
				puts $idfile $line
				set line $multicast(local,$j,$actual)
				puts $idfile $line
			}
		}
	}
   # End Multicast Stuff
   set line "#host"
   puts $idfile $line
   foreach k {unicast multicast} {
      foreach j {ipv4 ipv6} {
         foreach i {address interface} {
            set line $host($i,$j,$k)
            puts $idfile $line
         }
      }
   }
   set line "#MainDirectory"
   puts $idfile $line
   foreach k {unicast multicast} {
     foreach j {ipv4 ipv6} {
         set  line $scenarioDir($j,$k)
         puts $idfile $line
     }
   }
   set line "#NetworkType"
   puts $idfile $line
   set  line $ipVersion
   puts $idfile $line
   set  line $addressType
   puts $idfile $line
   if ($dly(startBool)) {
      set line "#StarTime"
      puts $idfile $line
      set  line $dly(start)
      puts $idfile $line
   }
   if ($dly(srcPortBool)) {
      set line "#SourcePort"
      puts $idfile $line
      set  line $dly(srcPort)
      puts $idfile $line
   }
   set line "#MgenDefs"
   puts $idfile $line
   foreach j {ipv4 ipv6} {
       set  line $dly(mgenPath,$j)
       puts $idfile $line
       set  line $dly(drecPath,$j)
       puts $idfile $line
       set  line $dly(resultsFile,$j)
       puts $idfile $line
       set  line $dly(title,$j)
       puts $idfile $line
   }
   set line "#Decodepath"
   puts $idfile $line
   set  line $decodepath
   puts $idfile $line
   set  line $decodepath4
   puts $idfile $line


   set line "#Mcalcpath"
   puts $idfile $line
   set  line $mcalcpath
   puts $idfile $line
   set  line $mcalcpath4
   puts $idfile $line

   if ($npf6(recvSocketSizeBool)) {
      set line "#NPF6recvSocketSize"
      puts $idfile $line
      set  line $npf6(recvSocketSize)
      puts $idfile $line
   }
   if ($npf6(recvMessageSizeBool)) {
      set line "#NPF6recvMessageSize"
      puts $idfile $line
      set  line $npf6(recvMessageSize)
      puts $idfile $line
   }
   if ($npf6(portNumberBool)) {
      set line "#NPF6portNumber"
      puts $idfile $line
      set  line $npf6(portNumber)
      puts $idfile $line
   }
   if ($npf6(sendMessageSizeBool)) {
      set line "#NPF6sendMessageSize"
      puts $idfile $line
      set  line $npf6(sendMessageSize)
      puts $idfile $line
   }
   if ($npf6(sendSocketSizeBool)) {
      set line "#NPF6sendSocketSize"
      puts $idfile $line
      set  line $npf6(sendSocketSize)
      puts $idfile $line
   }

   if ($npf6(tcpNodelay)) {
      set line "#NPF6tcpNodelay"
      puts $idfile $line
   }

   set line "#NPF6params"
   puts $idfile $line
   set  line $npf6(sXb)
   puts $idfile $line
   set  line $npf6(testType)
   puts $idfile $line
   set  line $npf6(testLength)
   puts $idfile $line
   set  line $npf6(netperfPath)
   puts $idfile $line
   set  line $npf6(netserverpath)
   puts $idfile $line
   set  line $npf6(resultsFileNpf)
   puts $idfile $line
   set  line $npf6(title)
   puts $idfile $line

   if ($npf(recvSocketSizeBool)) {
      set line "#NPF4recvSocketSize"
      puts $idfile $line
      set  line $npf(recvSocketSize)
      puts $idfile $line
   }
   if ($npf(recvMessageSizeBool)) {
      set line "#NPF4recvMessageSize"
      puts $idfile $line
      set  line $npf(recvMessageSize)
      puts $idfile $line
   }
   if ($npf(portNumberBool)) {
      set line "#NPF4portNumber"
      puts $idfile $line
      set  line $npf(portNumber)
      puts $idfile $line
   }
   if ($npf(sendMessageSizeBool)) {
      set line "#NPF4sendMessageSize"
      puts $idfile $line
      set  line $npf(sendMessageSize)
      puts $idfile $line
   }
   if ($npf(sendSocketSizeBool)) {
      set line "#NPF4sendSocketSize"
      puts $idfile $line
      set  line $npf(sendSocketSize)
      puts $idfile $line
   }

   if ($npf(tcpNodelay)) {
      set line "#NPF4tcpNodelay"
      puts $idfile $line
   }

   set line "#NPF4params"
   puts $idfile $line
   set  line $npf(sXb)
   puts $idfile $line
   set  line $npf(testType)
   puts $idfile $line
   set  line $npf(testLength)
   puts $idfile $line
   set  line $npf(netperfPath)
   puts $idfile $line
   set  line $npf(netserverpath)
   puts $idfile $line
   set  line $npf(resultsFileNpf)
   puts $idfile $line
   set  line $npf(title)
   puts $idfile $line

   set line "#GRAPHprm"
   puts $idfile $line
   puts $idfile $zoom_size
   puts $idfile $zoom_gap
   puts $idfile $zoom_tgap
   puts $idfile $zoom_sizey

   if ($dly(startBool6)) {
      set line "#StarTime6"
      puts $idfile $line
      set  line $dly(start6)
      puts $idfile $line
   }
   if ($dly(srcPortBool6)) {
      set line "#SourcePort6"
      puts $idfile $line
      set  line $dly(srcPort6)
      puts $idfile $line
   }
   if ($KeySocket) {
      set line "#Sock6"
      puts $idfile $line
      set  line $socksize
      puts $idfile $line
   }
   if ($KeySource) {
      set line "#Source6"
      puts $idfile $line
      set  line $ipv6SourceAddress
      puts $idfile $line
   }

   set line "#ConfInfo"
   puts $idfile $line
   puts $idfile $ConfInfo

   set line "#Xview"
   puts $idfile $line
   puts $idfile $_xviewCMD
   puts $idfile   $_sshCMD

   ###########################################
   #SAVE ALL THE INFORMATION FOR ALL FLOW IPv4
   ###########################################
   for {set countFL 1} {$countFL <= $flow(number)} {incr countFL}  \
   { 
      set line "#FLOW4"
      puts $idfile $line

      #Standard parameters
      set line $countFL
      puts $idfile $line
      set line $flow(start,$countFL)  
      puts $idfile $line
      set line $flow(stop,$countFL)  
      puts $idfile $line
      set line $flow(port,$countFL)  
      puts $idfile $line
      set line $flow(pattern,$countFL) 
      puts $idfile $line
      set line $flow(rate,$countFL) 
      puts $idfile $line
      set line $flow(size,$countFL) 
      puts $idfile $line
      set line $flow(tosBool,$countFL) 
      puts $idfile $line
      set line $flow(tos,$countFL) 
      puts $idfile $line
      set line $flow(rsvpBool,$countFL)    
      puts $idfile $line
      set line $flow(rsvp,$countFL) 
      puts $idfile $line
      set line $flow(resv,$countFL) 
      puts $idfile $line
      set line $flow(style,$countFL) 
      puts $idfile $line

      #Modifications
      set line $mod(number,$countFL)
      puts $idfile $line
      for {set countFLm 1} {$countFLm <= $mod(number,$countFL)} {incr countFLm}  \
      { 
         set line $mod(start,$countFLm,$countFL)  
         puts $idfile $line
         set line $mod(pattern,$countFLm,$countFL) 
         puts $idfile $line
         set line $mod(rate,$countFLm,$countFL) 
         puts $idfile $line
         set line $mod(size,$countFLm,$countFL) 
         puts $idfile $line
         set line $mod(tosBool,$countFLm,$countFL) 
         puts $idfile $line
         set line $mod(tos,$countFLm,$countFL) 
         puts $idfile $line
         set line $mod(rsvpBool,$countFLm,$countFL)    
         puts $idfile $line
         set line $mod(rsvp,$countFLm,$countFL) 
         puts $idfile $line
         set line $mod(resv,$countFLm,$countFL) 
         puts $idfile $line
         set line $mod(style,$countFLm,$countFL) 
         puts $idfile $line
      }
      set line $flow(name,$countFL) 
      puts $idfile $line
   }

   ###########################################
   #SAVE ALL THE INFORMATION FOR ALL FLOW IPv6
   ###########################################
   for {set countFL6 1} {$countFL6 <= $flow6(number)} {incr countFL6}  \
   { 
      set line "#FLOW6"
      puts $idfile $line

      #Standard parameters
      set line $countFL6
      puts $idfile $line
      set line $flow6(start,$countFL6)  
      puts $idfile $line
      set line $flow6(stop,$countFL6)  
      puts $idfile $line
      set line $flow6(port,$countFL6)  
      puts $idfile $line
      set line $flow6(pattern,$countFL6) 
      puts $idfile $line
      set line $flow6(rate,$countFL6) 
      puts $idfile $line
      set line $flow6(size,$countFL6) 
      puts $idfile $line
      set line $flow6(tosBool,$countFL6) 
      puts $idfile $line
      set line $flow6(tos,$countFL6)
      puts $idfile $line

      #Modifications
      set line $mod6(number,$countFL6)
      puts $idfile $line
      for {set countFL6m 1} {$countFL6m <= $mod6(number,$countFL6)} {incr countFL6m}  \
      { 
         set line $mod6(start,$countFL6m,$countFL6)  
         puts $idfile $line
         set line $mod6(pattern,$countFL6m,$countFL6) 
         puts $idfile $line
         set line $mod6(rate,$countFL6m,$countFL6) 
         puts $idfile $line
         set line $mod6(size,$countFL6m,$countFL6) 
         puts $idfile $line
         set line $mod6(tosBool,$countFL6m,$countFL) 
         puts $idfile $line
         set line $mod6(tos,$countFL6m,$countFL) 
         puts $idfile $line
      }
      set line $flow6(name,$countFL6) 
      puts $idfile $line
   }


   ###############################################
   #SAVE ALL THE INFORMATION FOR Custom Parameters
   ###############################################
   #Mgen4

      set line "#CustomM4"
      puts $idfile $line
      puts $idfile $countPU4
      set selList [lsort [array names paramU4]]
      for {set count 0} {$count < $countPU4} {incr count} \
      {
         set tmp [lindex $selList $count]
         puts $idfile $tmp 
      }

   #Mgen6

      set line "#CustomM6"
      puts $idfile $line
      puts $idfile $countPU6
      set selList [lsort [array names paramU6]]
      for {set count 0} {$count < $countPU6} {incr count} \
      {
         set tmp [lindex $selList $count]
         puts $idfile $tmp 
      }
   #Netperf4

      set line "#CustomN4"
      puts $idfile $line
      puts $idfile $customEnd
      for {set i 1} {$i<=$customEnd} {incr i} \
      {
         puts $idfile $customparams(name,$i)
         puts $idfile $customparams(value,$i)
      }

   #Netperf6

      set line "#CustomN6"
      puts $idfile $line
      puts $idfile $customEnd6
      for {set i 1} {$i<=$customEnd6} {incr i} \
      {
         puts $idfile $customparams6(name,$i)
         puts $idfile $customparams6(value,$i)
      }


   #####################################################################
   set line "###END"
   puts $idfile $line
   set line "###END"
   puts $idfile $line
   set line "#this lines will be ignored"
   puts $idfile $line
   set line "#this lines will be ignored"
   puts $idfile $line
   catch {close $idfile}
   $fR.conf.l1 configure -text "$GlobalFileConf"
}
