###############################################
# Copyright 2002, 2003 Ren Serral,           #
#                                             #
# delaym4a.tcl - Multicast Delay IPv4 Manager #
#       v1.0 (10-2002)                        #
###############################################

#   This file is part of NetMeter.
#
#   NetMeter is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   NetMeter is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with NetMeter; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

###################################################################
#------------------------------------------------------------------
#             Delay:Dm4      (Multicast Ipv4 case)
#------------------------------------------------------------------
###################################################################
# Atenci, ara aix s una cpia del fitxer delayu4a !!!!! has de fer la versi correcta
proc Delay:Dm4 {} \
{
   global mul4
   global dlyM 		;#dlyM array to hold data
   global flowM		;#flowM array to hold flows data
   global flowMLB	;#flows listbox
   global userLBM	;#custom params listbox
   global logDelayLBM	;#status console
   global runBM		;#run test button
   global modM

   global paramM4 pM4 countPM4 
   global sender receiver host
   global mcalcpath4
   global decodepath4
   global xflowview

   set xflowview 1977

   #mup frame for mgen and drec options plus
   #script listbox
   frame $mul4.mup
   pack  $mul4.mup -pady 3 -fill x

   #mup-left frame (options)
   frame $mul4.mup.left -bd 2 -relief groove
   pack  $mul4.mup.left -pady 3 -fill x -side left -anchor n

   #mup-right frame (script listboxes)
   frame $mul4.mup.right -bd 2 -relief groove
   pack  $mul4.mup.right -pady 3 -padx 3 -fill both -side right \
         -expand true -anchor n

   ##############################################################
   ##############################################################
   ## define widgets for mgen and drec OPTIONS
   ##############################################################
   label $mul4.mup.left.titleL -text "IPv4 - Mgen and Drec Options" -relief raised
   pack  $mul4.mup.left.titleL  -anchor c  -fill x -padx 3 -pady 3

   frame $mul4.mup.left.title
   pack  $mul4.mup.left.title -pady 2 -fill x
   label $mul4.mup.left.title.l -text "Title measure"
   pack  $mul4.mup.left.title.l -side left -padx 3
   entry $mul4.mup.left.title.e -textvariable dlyM(title,ipv4) -width 28
   pack  $mul4.mup.left.title.e -side right -padx 3


   #############################################################
   #### start ##################################################
   #############################################################

   frame $mul4.mup.left.start
   pack $mul4.mup.left.start -pady 3 -fill x
   checkbutton $mul4.mup.left.start.cB -variable dlyM(startBool) \
     -text "Start (hh:mm:ss)" -command {
      if $dlyM(startBool) {
          #enable entry
          $mul4.mup.left.start.e config -state normal -fg black
      } else {
          #disable entry
          $mul4.mup.left.start.e config -state disabled -fg gray
      }
   }
   pack $mul4.mup.left.start.cB -padx 3 -side left
   if $dlyM(startBool) {
      entry $mul4.mup.left.start.e -textvariable dlyM(start) -state normal
   } else {
      entry $mul4.mup.left.start.e -textvariable dlyM(start) -state disabled -fg gray
   }
   pack $mul4.mup.left.start.e -padx 3 -side right
   frame $mul4.mup.left.srcPort
   pack $mul4.mup.left.srcPort -pady 3 -fill x
   checkbutton $mul4.mup.left.srcPort.cB -variable dlyM(srcPortBool) \
     -text "Source Port" -command {
      if $dlyM(srcPortBool) {
         #enable entry
         $mul4.mup.left.srcPort.e config -state normal -fg black
      } else {
         #disable entry
         $mul4.mup.left.srcPort.e config -state disabled -fg gray
      }
   }
   if $dlyM(srcPortBool) {
      #enable entry
      entry $mul4.mup.left.srcPort.e -textvariable dlyM(srcPort) \
      -state normal
   } else {
      #disable entry
      entry $mul4.mup.left.srcPort.e -textvariable dlyM(srcPort) \
      -state disabled -fg gray
   }
   pack $mul4.mup.left.srcPort.cB -padx 3 -side left
   pack $mul4.mup.left.srcPort.e -padx 3 -side right


   #####################################################
   # flows list
   #####################################################
   #frame for flowM list:
   frame  $mul4.mup.left.flowl -bd 2 -relief groove
   pack $mul4.mup.left.flowl -fill x -pady 5
   #a label
   label $mul4.mup.left.flowl.label -text "Flows List" -relief sunken 
   pack $mul4.mup.left.flowl.label -side top -fill x  -padx 3
   #listbox for displaying currently defined
   #flows and their properties
   set flowMLB [listbox $mul4.mup.left.flowl.flowlist -height 9]
   set fsy [scrollbar $mul4.mup.left.flowl.flowsy -orient vertical \
   -command "$flowMLB yview"]
   $flowMLB config -yscrollcommand "$fsy set"
   pack $fsy -side right -fill y -pady 3
   pack $flowMLB -side left -fill both  -expand true -pady 3
   bind $mul4.mup.left.flowl.flowlist <Double-1> {
     Viewflow4
   }

   #####################################################
   #frame for flowM operations: add, delete, and MODify
   #####################################################
   frame  $mul4.mup.left.flow
   pack   $mul4.mup.left.flow -pady 5 -fill x
   button $mul4.mup.left.flow.addB -text "Add\nnew Flow" \
      -command { AddFlow 0 } -bd 2 -relief groove -width 7

   button $mul4.mup.left.flow.editB -text "Edit\nFlow" \
      -command { EditFlow 0 } -bd 2 -relief groove -width 4

   button $mul4.mup.left.flow.delB -text "Delete\nlast Flow" \
      -command DeleteFlow -bd 2 -relief groove -width 7

   button $mul4.mup.left.flow.modB -text "Add changes\nto Flow" \
      -command MODifyFlow -bd 2 -relief groove -width 9

   pack $mul4.mup.left.flow.editB  $mul4.mup.left.flow.addB $mul4.mup.left.flow.modB \
        $mul4.mup.left.flow.delB -padx 3 -anchor c -side left

   #############################################################
   ## Listbox View selected Flow
   #############################################################

   frame $mul4.mup.right.custom -bd 2 -relief groove
   pack  $mul4.mup.right.custom -fill x 

   frame  $mul4.mup.right.custom.b
   pack   $mul4.mup.right.custom.b -expand true -side bottom 
   label  $mul4.mup.right.custom.b.l -text "Parameters"
   pack   $mul4.mup.right.custom.b.l -side left
   button $mul4.mup.right.custom.b.b1 -text "Add" \
      -command AddParameterU4  -relief groove -width 2
   button $mul4.mup.right.custom.b.b2 -text "Edit" \
      -command EditParameterU4 -relief groove -width 2
   button $mul4.mup.right.custom.b.b3 -text "Del" \
      -command RemoveParameterU4 -bd 2 -relief groove -width 2

   set x "(parameters)"
   set paramM4($x) "0"
   eval tk_optionMenu $mul4.mup.right.custom.b.bx pM4 [lsort [array names paramM4 ]]
   $mul4.mup.right.custom.b.bx configure -width 20

   pack $mul4.mup.right.custom.b.b1 $mul4.mup.right.custom.b.b3\
   $mul4.mup.right.custom.b.b2 $mul4.mup.right.custom.b.bx -side left

   label $mul4.mup.right.custom.l -text "flow parameters (to select double click on flow list)"
   pack  $mul4.mup.right.custom.l -padx 2 -anchor c
   #frame for listbox and scrollbars:
   frame $mul4.mup.right.custom.lb
   pack $mul4.mup.right.custom.lb -pady 2 -fill both -expand true
   set  userLBM [listbox $mul4.mup.right.custom.lb.customLB -height 8]
   set  usy [scrollbar $mul4.mup.right.custom.lb.sY -orient vertical\
        -command "$userLBM yview"]
   set  usx [scrollbar $mul4.mup.right.custom.lb.sX -orient horizontal\
        -command "$userLBM xview"]
   $userLBM config -yscrollcommand "$usy set" -xscrollcommand "$usx set"

   pack $usy -side right -fill y -pady 2
   pack $usx -side bottom -fill x -padx 2
   pack $userLBM -fill both -padx 2 -pady 2 -side left -expand true

   #############################################################
   ## frame for path settings and features :)
   #############################################################
   #frame for path settings:
   frame $mul4.mup.right.path
   pack  $mul4.mup.right.path -fill x -pady 3 \
         -expand true -padx 3

   frame $mul4.mup.right.path.mgenPath
   pack  $mul4.mup.right.path.mgenPath -pady 2 -fill x
   label $mul4.mup.right.path.mgenPath.l -text "(SRC) Set Mgen Path"
   pack  $mul4.mup.right.path.mgenPath.l -side left -padx 3
   entry $mul4.mup.right.path.mgenPath.e -textvariable dlyM(mgenPath,ipv4) \
         -width 24
   pack $mul4.mup.right.path.mgenPath.e -side right -padx 3

   frame $mul4.mup.right.path.drecPath
   pack  $mul4.mup.right.path.drecPath -pady 2 -fill x
   label $mul4.mup.right.path.drecPath.l -text "(DST) Set Drec Path"
   pack  $mul4.mup.right.path.drecPath.l -side left -padx 3
   entry $mul4.mup.right.path.drecPath.e -textvariable dlyM(drecPath,ipv4) \
         -width 24
   pack $mul4.mup.right.path.drecPath.e -side right -padx 3

   frame $mul4.mup.right.path.decodepath
   pack  $mul4.mup.right.path.decodepath -pady 2 -fill x
   label $mul4.mup.right.path.decodepath.l -text "(DST)Set Decode Path"
   pack  $mul4.mup.right.path.decodepath.l -side left -padx 3 
   entry $mul4.mup.right.path.decodepath.e -textvariable decodepath4      \
         -width 24
   pack $mul4.mup.right.path.decodepath.e -side right -padx 3 

   frame $mul4.mup.right.path.mcalc
   pack $mul4.mup.right.path.mcalc -pady 2 -fill x
   label $mul4.mup.right.path.mcalc.l -text "(LOC) Set Mcalc path"
   pack $mul4.mup.right.path.mcalc.l -side left -padx 3
   entry $mul4.mup.right.path.mcalc.e -textvariable  mcalcpath4 \
         -width 24
   pack $mul4.mup.right.path.mcalc.e -side right -padx 3

   frame $mul4.mup.right.path.delaySave
   pack $mul4.mup.right.path.delaySave -pady 2 -fill x
   label $mul4.mup.right.path.delaySave.l -text "(LOC) Save Results File"
   pack $mul4.mup.right.path.delaySave.l -side left -padx 3
   entry $mul4.mup.right.path.delaySave.e -textvariable dlyM(resultsFile,ipv4)\
         -width 24
   pack $mul4.mup.right.path.delaySave.e -side right -padx 3

   #mdown frame
   frame $mul4.mdown
   pack $mul4.mdown -fill x

   #frame for action buttons:
   frame $mul4.mdown.action -bd 2 -relief groove
   pack $mul4.mdown.action -padx 3 -padx 3 -side left

   #and the buttons
   set runBM [button $mul4.mdown.action.rB -text "Run Test" \
       -command RunMDelayTest  -width 16]
   button $mul4.mdown.action.resgB -text "Graphic Results" \
       -command "NetGRAPH mcl" -width 16
   button $mul4.mdown.action.resdB -text "Graphic Distributions" \
       -command Distribution -width 16
   button $mul4.mdown.action.quitB -text "Quit" \
       -command Quit -width 16

   pack $mul4.mdown.action.rB $mul4.mdown.action.resgB \
       $mul4.mdown.action.resdB $mul4.mdown.action.quitB \
       -anchor n

   #console frame,listbox and scrollbar:
   frame $mul4.mdown.consoleF
   pack $mul4.mdown.consoleF -pady 2 -side left \
   -fill x -anchor n -expand true

   set logDelayLBM [listbox $mul4.mdown.consoleF.consoleLB \
   -height 7 -font default]
   set csy [scrollbar $mul4.mdown.consoleF.sY -orient vertical \
   -command "$logDelayLBM yview"]
   $logDelayLBM config -yscrollcommand "$csy set"
   pack $csy -fill y -side right
   pack $logDelayLBM -fill both -side left -expand true

   $flowMLB delete 0 end
   $flowMLB see end
   for {set countFL 1} {$countFL <= $flowM(number)} {incr countFL}  \
   { 
     $flowMLB insert end [format "Flow  %02d   -   Mods  %02d  -  %s" \
     $countFL $modM(number,$countFL) $flowM(name,$countFL) ]
   }
   $flowMLB see end
};

###################################################################
#------------------------------------------------------------------
#             ADDFLOW
#------------------------------------------------------------------
###################################################################
proc AddMFlow { action } \
{
   global flowM	;# flowM data
   global flowMLB	;# flowM list(box)

   global modM	;# flowM modifier data
   global done	;# ok or cancel ?

   #deal with data

   if { $action == 0 } \
   {
      incr flowM(number)
      # VERY usefull when write sequency flows ;)
      if { $flowM(number) > 1 } \
      {
         set flowM(name,$flowM(number))    $flowM(name,[expr $flowM(number) - 1]) 
         set flowM(start,$flowM(number))   $flowM(stop,[expr $flowM(number) - 1]) 
         set flowM(stop,$flowM(number))    $flowM(stop,[expr $flowM(number) - 1]) 
         set flowM(port,$flowM(number))    [expr $flowM(port,[expr $flowM(number) - 1]) +1 ]
         set flowM(pattern,$flowM(number)) $flowM(pattern,[expr $flowM(number) - 1])
         set flowM(rate,$flowM(number))    $flowM(rate,[expr $flowM(number) - 1]) 
         set flowM(size,$flowM(number))    $flowM(size,[expr $flowM(number) - 1])  
      } else {
         set flowM(name,$flowM(number))  {}
         set flowM(start,$flowM(number)) {}
         set flowM(stop,$flowM(number))  {}
         set flowM(port,$flowM(number))  {}
         set flowM(pattern,$flowM(number)) PERIODIC
         set flowM(rate,$flowM(number))  {}
         set flowM(size,$flowM(number))  {}
      }
      set flowM(tosBool,$flowM(number)) 0
      set flowM(tos,$flowM(number)) {} 
      set flowM(rsvpBool,$flowM(number)) 0
      set flowM(rsvp,$flowM(number)) {}
      set flowM(resv,$flowM(number)) {}
      set flowM(style,$flowM(number)) WF
      set modM(number,$flowM(number)) 0
   }
  

   set done not_yet
   #make a dialog window

   toplevel .dialog
   wm title .dialog "Add new Flow No. $flowM(number)"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   #define widgets:

   #frames for standard params, optional
   #params and ok-cancel buttons
   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3
   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
   -anchor n -expand true


   #standard params
   frame .dialog.fr1.name -bd 2 -relief groove
   pack  .dialog.fr1.name -pady 3 -padx 3 -fill x
   label .dialog.fr1.name.l -text "Flow Name"
   pack  .dialog.fr1.name.l -side top -padx 3
   entry .dialog.fr1.name.e -textvariable flowM(name,$flowM(number)) -width 30
   pack  .dialog.fr1.name.e -side bottom -padx 3

   frame .dialog.fr1.fstart
   pack  .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "Flow Start (ms)"
   pack  .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable flowM(start,$flowM(number)) -width 10
   pack .dialog.fr1.fstart.e -side right -padx 3

   #(relative) flow stop time
   frame .dialog.fr1.fstop
   pack .dialog.fr1.fstop -pady 3 -fill x
   label .dialog.fr1.fstop.l -text "Flow Stop (ms)"
   pack .dialog.fr1.fstop.l -side left -padx 3
   entry .dialog.fr1.fstop.e -textvariable flowM(stop,$flowM(number))  -width 10
   pack .dialog.fr1.fstop.e -side right -padx 3

   #an explanation:
   label .dialog.fr1.exp -text "(Relative to test start)"
   pack .dialog.fr1.exp -padx 3 -pady 2

   #port number. This will be verified at last
   #to have only flows with unique port numbers

   frame .dialog.fr1.fport
   pack .dialog.fr1.fport -pady 3 -fill x
   label .dialog.fr1.fport.l -text "Destination Port"
   pack .dialog.fr1.fport.l -side left -padx 3
   entry .dialog.fr1.fport.e -textvariable flowM(port,$flowM(number)) -width 10
   pack .dialog.fr1.fport.e -side right -padx 3


   #pattern type frame, label and radiobuttons
   frame .dialog.fr1.fpattern
   pack .dialog.fr1.fpattern -pady 3 -fill x
   label .dialog.fr1.fpattern.l -text "Pattern"
   pack .dialog.fr1.fpattern.l -side left -padx 3 -fill x
   frame .dialog.fr1.fpattern.rbF -bd 2 -relief groove
   pack .dialog.fr1.fpattern.rbF -padx 3 -pady 3 -side right
   radiobutton .dialog.fr1.fpattern.rbF.rb1 -text PERIODIC \
   -variable flowM(pattern,$flowM(number)) -value PERIODIC
   radiobutton .dialog.fr1.fpattern.rbF.rb2 -text POISSON \
   -variable flowM(pattern,$flowM(number)) -value POISSON
   pack .dialog.fr1.fpattern.rbF.rb1 .dialog.fr1.fpattern.rbF.rb2 \
   -padx 2 -pady 2 -anchor w

   #rate:
   frame .dialog.fr1.frate
   pack .dialog.fr1.frate -pady 3 -fill x
   label .dialog.fr1.frate.l -text "Rate (packets/sec)"
   pack .dialog.fr1.frate.l -side left -padx 3
   entry .dialog.fr1.frate.e -textvariable flowM(rate,$flowM(number)) -width 10
   pack .dialog.fr1.frate.e -side right -padx 3

   #UDP packet payload size
   frame .dialog.fr1.fsize
   pack .dialog.fr1.fsize -pady 3 -fill x
   label .dialog.fr1.fsize.l -text "Packet Size (bytes)"
   pack .dialog.fr1.fsize.l -side left -padx 3
   entry .dialog.fr1.fsize.e -textvariable flowM(size,$flowM(number)) \
   -width 10
   pack .dialog.fr1.fsize.e -side right -padx 3

   #frame 2: optional params

   #tos field:

   frame .dialog.fr2.tosF
   pack .dialog.fr2.tosF -pady 3 -fill x -anchor n

   checkbutton .dialog.fr2.tosF.cb -text "Type-of-Service" \
   -variable flowM(tosBool,$flowM(number)) -command {
   if $flowM(tosBool,$flowM(number)) {
       .dialog.fr2.tosF.e config -state normal -fg black
       } else {
       .dialog.fr2.tosF.e config -state disabled -fg gray
       }
   }
   pack .dialog.fr2.tosF.cb -side left -padx 3
   entry .dialog.fr2.tosF.e -textvariable flowM(tos,$flowM(number)) \
   -state disabled -width 10 -fg gray
   pack .dialog.fr2.tosF.e -side right -padx 3


   #RSVP:

   frame .dialog.fr2.rsvp
   pack .dialog.fr2.rsvp -pady 3 -fill x -anchor n
   checkbutton .dialog.fr2.rsvp.cb -text "Use RSVP" \
   -variable flowM(rsvpBool,$flowM(number)) -command {
   if $flowM(rsvpBool,$flowM(number)) {
       pack .dialog.fr2.rsvp.params -anchor n -fill x \
       -pady 3 -padx 3
       } else {
       pack forget .dialog.fr2.rsvp.params
       }
   }
   pack .dialog.fr2.rsvp.cb -padx 3 -anchor w

   frame .dialog.fr2.rsvp.params -bd 2 -relief groove
   #no need to pack it :-)

   label .dialog.fr2.rsvp.params.l -text "RSVP Parameters"
   pack .dialog.fr2.rsvp.params.l -padx 3 -pady 3 -anchor c
   entry .dialog.fr2.rsvp.params.e -textvariable flowM(rsvp,$flowM(number))
   pack .dialog.fr2.rsvp.params.e -fill x -padx 3 -pady 3

   frame .dialog.fr2.rsvp.params.style
   pack .dialog.fr2.rsvp.params.style -fill x
   label .dialog.fr2.rsvp.params.style.l -text "RESV Style"
   pack .dialog.fr2.rsvp.params.style.l -side left -padx 3

   frame .dialog.fr2.rsvp.params.style.rbF -bd 2 -relief groove
   pack .dialog.fr2.rsvp.params.style.rbF -padx 3 -pady 3

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb1 \
   -text "WF (Wildcard)" -variable flowM(style,$flowM(number)) -value WF

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb2 \
   -text "FF (Fixed-Filter)" -variable flowM(style,$flowM(number)) -value FF

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb3 \
   -text "SE (Shared-Explicit)" -variable flowM(style,$flowM(number)) -value SE

   pack .dialog.fr2.rsvp.params.style.rbF.rb1 \
   .dialog.fr2.rsvp.params.style.rbF.rb2 \
   .dialog.fr2.rsvp.params.style.rbF.rb3 -pady 3 -padx 3 -anchor w


   label .dialog.fr2.rsvp.params.lr -text "RESV Parameters"
   pack .dialog.fr2.rsvp.params.lr -padx 3 -pady 3 -anchor c
   entry .dialog.fr2.rsvp.params.er -textvariable flowM(resv,$flowM(number))
   pack .dialog.fr2.rsvp.params.er -fill x -padx 3 -pady 3

   #ok-cancel buttons on 3rd frame

   button .dialog.fr3.ok -text OK -command {
   set done ok
   destroy .dialog
   } -width 6

   button .dialog.fr3.cancel -text Cancel -command {
   set done cancel
   destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
   -padx 3 -pady 3


   grab .dialog
   tkwait window .dialog


   if ![string compare $done cancel] {
     #cancel was pressed
     #unset data and decrement number of flows
     foreach elem {start stop port rate pattern size  tosBool tos rsvpBool rsvp resv style} \
  {
        unset flowM($elem,$flowM(number))
     }
     unset modM(number,$flowM(number))
     incr flowM(number) -1
     return
   }

   #ok was pressed:
   #first verify that standard parameters are filled
   foreach elem {start stop port rate size} \
   {
      if ![string compare $flowM($elem,$flowM(number)) ""] \
      {
         tk_messageBox -message "Missing Flow parameteres...!!"
         AddFlow 1 
         return
      }
   }

   #check port; must be unique for each flow
   for {set i 1} {$i < $flowM(number)} {incr i} \
   {
      if { $flowM(port,$flowM(number)) == $flowM(port,$i) }  \
      {
         tk_messageBox -message "Port value already used on flow $i"
         AddFlow 1 
         return
      }
   }

   #data is ok, mupdate listbox:
   $flowMLB insert end [format "Flow  %02d   -   Mods  %02d  -  %s" \
   $flowM(number) $modM(number,$flowM(number)) $flowM(name,$flowM(number)) ]
};

###################################################################
#------------------------------------------------------------------
#             MODifyFlow
#------------------------------------------------------------------
###################################################################
proc MODifyMFlow {} \
{

   global flowM modM flowMLB done flowNr

   #get the line index
   set flowNr [$flowMLB curselection]

   if {$flowNr == ""} {
   #nothing selected
   return
   }
   #else
   incr flowNr
   #deal with data
   incr modM(number,$flowNr)
   set modM(start,$modM(number,$flowNr),$flowNr) \
   $flowM(start,$flowNr)

   #no port choice; is better that one flow
   #has just one port - else user may be
   #confused - if a MOD command change the port
   #so that this new port is already used by
   #another flow, apckets are dropped
   #So, it is better not to allow the user to
   #change port in a MOD command
   #set modM(port,$modM(number,$flowNr),$flowNr) \
   #$flowM(port,$flowNr)
   set modM(pattern,$modM(number,$flowNr),$flowNr) \
   $flowM(pattern,$flowNr)
   set modM(rate,$modM(number,$flowNr),$flowNr) \
   $flowM(rate,$flowNr)
   set modM(size,$modM(number,$flowNr),$flowNr) \
   $flowM(size,$flowNr)
   set modM(tosBool,$modM(number,$flowNr),$flowNr) \
   $flowM(tosBool,$flowNr)
   set modM(tos,$modM(number,$flowNr),$flowNr) \
   $flowM(tos,$flowNr)
   set modM(rsvpBool,$modM(number,$flowNr),$flowNr) \
   $flowM(rsvpBool,$flowNr)
   set modM(rsvp,$modM(number,$flowNr),$flowNr) \
   $flowM(rsvp,$flowNr)
   set modM(resv,$modM(number,$flowNr),$flowNr) \
   $flowM(resv,$flowNr)
   set modM(style,$modM(number,$flowNr),$flowNr) \
   $flowM(style,$flowNr)
   set done not_yet

   #make a dialog window
   toplevel .dialog
   wm title .dialog "MODify Flow $flowNr"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   #define widgets:

   #frames for standard params, optional
   #params and ok-cancel buttons

   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3
   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
   -anchor n -expand true
   #standard params
   #(relative) flow start time:
   frame .dialog.fr1.fstart
   pack .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "MODify Flow Start (ms)"
   pack .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable modM(start,$modM(number,$flowNr),$flowNr) \
   -width 10
   pack .dialog.fr1.fstart.e -side right -padx 3

   #an explanation:
   label .dialog.fr1.exp -text "(Relative to test start)"
   pack .dialog.fr1.exp -padx 3 -pady 2

   #pattern type frame, label and radiobuttons
   frame .dialog.fr1.fpattern
   pack .dialog.fr1.fpattern -pady 3 -fill x
   label .dialog.fr1.fpattern.l -text "Pattern"
   pack .dialog.fr1.fpattern.l -side left -padx 3 -fill x
   frame .dialog.fr1.fpattern.rbF -bd 2 -relief groove
   pack .dialog.fr1.fpattern.rbF -padx 3 -pady 3 -side right
   radiobutton .dialog.fr1.fpattern.rbF.rb1 -text PERIODIC \
   -variable modM(pattern,$modM(number,$flowNr),$flowNr)  -value PERIODIC
   radiobutton .dialog.fr1.fpattern.rbF.rb2 -text POISSON \
   -variable modM(pattern,$modM(number,$flowNr),$flowNr)  -value POISSON
   pack .dialog.fr1.fpattern.rbF.rb1 .dialog.fr1.fpattern.rbF.rb2 \
   -padx 2 -pady 2 -anchor w

   #rate:

   frame .dialog.fr1.frate
   pack .dialog.fr1.frate -pady 3 -fill x
   label .dialog.fr1.frate.l -text "Rate (packets/sec)"
   pack .dialog.fr1.frate.l -side left -padx 3
   entry .dialog.fr1.frate.e -textvariable modM(rate,$modM(number,$flowNr),$flowNr) \
   -width 10
   pack .dialog.fr1.frate.e -side right -padx 3

   #UDP packet payload size
   frame .dialog.fr1.fsize
   pack .dialog.fr1.fsize -pady 3 -fill x
   label .dialog.fr1.fsize.l -text "Packet Size (bytes)"
   pack .dialog.fr1.fsize.l -side left -padx 3
   entry .dialog.fr1.fsize.e -textvariable modM(size,$modM(number,$flowNr),$flowNr) \
   -width 10
   pack .dialog.fr1.fsize.e -side right -padx 3

   #frame 2: optional params

   #tos field:

   frame .dialog.fr2.tosF
   pack .dialog.fr2.tosF -pady 3 -fill x -anchor n

   checkbutton .dialog.fr2.tosF.cb -text "Type-of-Service" \
   -variable modM(tosBool,$modM(number,$flowNr),$flowNr)  -command {
   if $modM(tosBool,$modM(number,${flowNr}),${flowNr})  {
       .dialog.fr2.tosF.e config -state normal -fg black
       } else {
       .dialog.fr2.tosF.e config -state disabled -fg gray
       }
   }
   pack .dialog.fr2.tosF.cb -side left -padx 3
   entry .dialog.fr2.tosF.e -textvariable modM(tos,$modM(number,$flowNr),$flowNr) \
   -state disabled -width 10 -fg gray
   pack .dialog.fr2.tosF.e -side right -padx 3


   #RSVP:

   frame .dialog.fr2.rsvp
   pack .dialog.fr2.rsvp -pady 3 -fill x -anchor n
   checkbutton .dialog.fr2.rsvp.cb -text "Use RSVP" \
   -variable modM(rsvpBool,$modM(number,$flowNr),$flowNr) -command {
   if $modM(rsvpBool,$modM(number,${flowNr}),${flowNr}) {
       pack .dialog.fr2.rsvp.params -anchor n -fill x \
       -pady 3 -padx 3
       } else {
       pack forget .dialog.fr2.rsvp.params
       }
   }
   pack .dialog.fr2.rsvp.cb -padx 3 -anchor w

   frame .dialog.fr2.rsvp.params -bd 2 -relief groove
   #no need to pack it :-)

   label .dialog.fr2.rsvp.params.l -text "RSVP Parameters"
   pack .dialog.fr2.rsvp.params.l -padx 3 -pady 3 -anchor c
   entry .dialog.fr2.rsvp.params.e -textvariable modM(rsvp,$modM(number,$flowNr),$flowNr)
   pack .dialog.fr2.rsvp.params.e -fill x -padx 3 -pady 3

   frame .dialog.fr2.rsvp.params.style
   pack .dialog.fr2.rsvp.params.style -fill x
   label .dialog.fr2.rsvp.params.style.l -text "RESV Style"
   pack .dialog.fr2.rsvp.params.style.l -side left -padx 3

   frame .dialog.fr2.rsvp.params.style.rbF -bd 2 -relief groove
   pack .dialog.fr2.rsvp.params.style.rbF -padx 3 -pady 3

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb1 \
   -text "WF (Wildcard)" -variable modM(style,$modM(number,$flowNr),$flowNr) -value WF

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb2 \
   -text "FF (Fixed-Filter)" -variable modM(style,$modM(number,$flowNr),$flowNr) -value FF

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb3 \
   -text "SE (Shared-Explicit)" -variable modM(style,$modM(number,$flowNr),$flowNr) -value SE

   pack .dialog.fr2.rsvp.params.style.rbF.rb1 \
   .dialog.fr2.rsvp.params.style.rbF.rb2 \
   .dialog.fr2.rsvp.params.style.rbF.rb3 -pady 3 -padx 3 -anchor w


   label .dialog.fr2.rsvp.params.lr -text "RESV Parameters"
   pack .dialog.fr2.rsvp.params.lr -padx 3 -pady 3 -anchor c
   entry .dialog.fr2.rsvp.params.er -textvariable modM(resv,$modM(number,$flowNr),$flowNr)
   pack .dialog.fr2.rsvp.params.er -fill x -padx 3 -pady 3

   #ok-cancel buttons on 3rd frame

   button .dialog.fr3.ok -text OK -command {
   set done ok
   destroy .dialog
   } -width 6

   button .dialog.fr3.cancel -text Cancel -command {
   set done cancel
   destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
   -padx 3 -pady 3

   #to synchronize widgets states:

   if $modM(tosBool,$modM(number,${flowNr}),${flowNr})  {
       .dialog.fr2.tosF.e config -state normal -fg black
       } else {
       .dialog.fr2.tosF.e config -state disabled -fg gray
       }
   if $modM(rsvpBool,$modM(number,${flowNr}),${flowNr}) {
       pack .dialog.fr2.rsvp.params -anchor n -fill x \
       -pady 3 -padx 3
       } else {
       pack forget .dialog.fr2.rsvp.params
       }

   grab .dialog
   tkwait window .dialog


   if ![string compare $done cancel] {
   #cancel was pressed

   #unset data and decrement number of flows
   foreach elem {start rate pattern size \
   tosBool tos rsvpBool rsvp resv style} {
   unset modM($elem,$modM(number,$flowNr),$flowNr)
   }
   incr modM(number,$flowNr) -1
   return
   }

   #ok was pressed:

   #first verify that standard parameters are filled

   foreach elem {start rate size} {
	   if ![string compare $modM($elem,$modM(number,$flowNr),$flowNr) ""] {
			tk_messageBox -message "Flow MOD not added"
			#unset data and decrement number of flows
			foreach elem {start rate pattern size \
			  tosBool tos rsvpBool rsvp resv style} {
				unset modM($elem,$modM(number,$flowNr),$flowNr)
			}
			incr modM(number,$flowNr) -1
			return
		};#end if
   };#end foreach

   #in this point, data is ok
   #even if tos or rsvp are selected, but not filled,
   #this options can be canceled
   #mupdate listbox:

   $flowMLB delete [expr $flowNr - 1]
   $flowMLB insert [expr $flowNr - 1]  \
   [format "Flow  %02d   -   Mods  %02d  -  %s" \
   $flowNr $modM(number,$flowNr) $flowM(name,$flowNr) ]
};

###################################################################
#------------------------------------------------------------------
#             DELETEFLOW
#------------------------------------------------------------------
###################################################################
proc DeleteMFlow {} \
{
   #delete last flow

   global flowM modM flowMLB
   global xflowview
   global userLBM

   #check number of flows:
   if !$flowM(number) {
   return
   }

   #tk_messageBox -message "x = $xflowview"  
   #tk_messageBox -message "n = $flowM(number)"  
   if  { $xflowview == $flowM(number) } \
   {
      $userLBM delete 0 end
   }
   
	#first, delete all the modM data associated
   #with the flow:

   for {set i 1} {$i <= $modM(number,$flowM(number))} {incr i} {

   foreach elem {start rate pattern size tosBool tos \
   rsvpBool rsvp resv style} {
   unset modM($elem,$i,$flowM(number))
   };# end foreach


   };#end for
   #unset modM counter:
   unset modM(number,$flowM(number))

   #then, delete the flowM (last flowM)

   foreach elem {start stop port rate pattern size \
   tosBool tos rsvpBool rsvp resv style } {
   unset flowM($elem,$flowM(number))
   };#end foreach

   #decrement flowM number

   incr flowM(number) -1

   #mupdate listbox

   $flowMLB delete end end

}

###################################################################
#------------------------------------------------------------------
#             Viewflow4
#------------------------------------------------------------------
###################################################################
proc ViewMflow4 {} \
{
   global userLBM
   global flowM modM flowMLB
   global xflowview

   set flowNr [$flowMLB curselection]
   #tk_messageBox -message "fnr = $flowNr"  
   if {$flowNr == ""} {
     #nothing selected
     return
   }
   incr flowNr
   set xflowview $flowNr
   $userLBM delete 0 end
   $userLBM insert end "Flow number (ID): $flowNr"
   $userLBM insert end "Flow name: $flowM(name,$flowNr)"
   $userLBM insert end "Start time (ON): $flowM(start,$flowNr)"
   $userLBM insert end "Stop time (OFF): $flowM(stop,$flowNr)"
   $userLBM insert end "Destination port number: $flowM(port,$flowNr)"
   $userLBM insert end "Rate (packets/sec): $flowM(rate,$flowNr)"
   $userLBM insert end "Pattern: $flowM(pattern,$flowNr)"
   $userLBM insert end "UDP packet payload size: $flowM(size,$flowNr)"

   if $flowM(tosBool,$flowNr) {
      $userLBM insert end "-------------------------------------------------------"
      $userLBM insert end "IP TOS value: $flowM(tos,$flowNr)"
   }
   if $flowM(rsvpBool,$flowNr) {
      $userLBM insert end "-------------------------------------------------------"
      $userLBM insert end "RSVP parameters: $flowM(rsvp,$flowNr)"
      $userLBM insert end "Reservation style: $flowM(style,$flowNr)"
      $userLBM insert end "RESV parameters: $flowM(resv,$flowNr)"
   }

   #modM data:
   for {set i 1} {$i <= $modM(number,$flowNr)} {incr i} {
      $userLBM insert end "-------------------------------------------------------"
      $userLBM insert end "Modify flow n. $i"
      $userLBM insert end "Start time: $modM(start,$i,$flowNr)"
      $userLBM insert end "Rate:  $modM(rate,$i,$flowNr)"
      $userLBM insert end "Pattern  $modM(pattern,$i,$flowNr)"
      $userLBM insert end "UDP packet payload size:  $modM(size,$i,$flowNr)"
   };
   $userLBM see end
}


###################################################################
#------------------------------------------------------------------
#             AddParmaeter4
#------------------------------------------------------------------
###################################################################
proc AddMParameterU4 {} \
{
	global done paramName paramValue
	global paramM4 pM4 countPM4
	global mul4

	set paramName  ""
	set paramValue ""

	toplevel .addpu4
	wm title .addpu4 "Add Parameter"
	wm resizable .addpu4 0 0
	wm protocol  .addpu4 WM_DELETE_WINDOW {;#do nothing}
	frame .addpu4.nameF
	frame .addpu4.valueF
	frame .addpu4.buttonsF
	pack  .addpu4.nameF .addpu4.valueF .addpu4.buttonsF -pady 3

	#name
	label .addpu4.nameF.nameL -text "Name"
	entry .addpu4.nameF.nameE -textvariable paramName -width 45
	pack  .addpu4.nameF.nameL -side left -padx 2
	pack  .addpu4.nameF.nameE -side right -padx 2

	#value
	label .addpu4.valueF.valueL -text "Value"
	entry .addpu4.valueF.valueE -textvariable paramValue -width 45
	pack  .addpu4.valueF.valueL -side left -padx 2
	pack  .addpu4.valueF.valueE -side right -padx 2

	#buttons
	button .addpu4.buttonsF.okB -text OK -command {set done ok}
	button .addpu4.buttonsF.cancelB -text Cancel -command {set done cancel}
	pack  .addpu4.buttonsF.okB .addpu4.buttonsF.cancelB  -side left -anchor c -expand true

	set done not_yet
	grab .addpu4
	tkwait variable done
	grab release .addpu4
	destroy .addpu4

	#OK or Cancel pressed, at this point
	if {![string compare $done ok]} \
	{
		if {![string compare "" [string trim $paramName]]} \
		{
			#nothing eligible was specified
			return
		}
		incr countPM4
		set tmp "$paramName: $paramValue"
		set paramM4($tmp) $countPM4
		set pM4 "$tmp"

		destroy  $mul4.mup.right.custom.b.bx
		eval tk_optionMenu $mul4.mup.right.custom.b.bx pM4 [lsort [array names paramM4 ]]
		$mul4.mup.right.custom.b.bx configure -width 20
		pack    $mul4.mup.right.custom.b.bx  -side left
	}
}

###################################################################
#------------------------------------------------------------------
#             Remove Parameter U4
#------------------------------------------------------------------
###################################################################
proc RemoveMParameterU4 {} \
{
	global paramM4 pM4 countPM4
	global mul4

	if ![string compare $pM4 "(parameters)"] \
	{
		return
		#nothing selected
	}
	unset paramM4($pM4)
	set pM4 "(parameters)"
	destroy  $mul4.mup.right.custom.b.bx
	eval tk_optionMenu $mul4.mup.right.custom.b.bx pM4 [lsort [array names paramM4 ]]
	$mul4.mup.right.custom.b.bx configure -width 20
	pack     $mul4.mup.right.custom.b.bx  -side left
	incr countPM4 -1
}

###################################################################
#------------------------------------------------------------------
#             Edit Parameter U4
#------------------------------------------------------------------
###################################################################
proc EditMParameterU4 {} \
{
	global done paramName paramValue
	global paramM4 pM4 countPM4
	global mul4


	if ![string compare $pM4 "(parameters)"] \
	{
		return
		#nothing selected
	}

	set line $pM4
	set lindex     [string first : $line 0]
	set paramName  [string range   $line 0 [expr $lindex]]
	set paramValue [string range   $line   [expr $lindex +2]  [string length $line]]

	toplevel .dialog
	wm title .dialog "Edit Parameter"
	wm resizable .dialog 0 0
	wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

	label .dialog.titleL -text "Insert New Value"
	frame .dialog.paramF
	frame .dialog.buttonsF
	pack .dialog.titleL .dialog.paramF .dialog.buttonsF -pady 3
	label .dialog.paramF.numeL -text "$paramName"

	entry .dialog.paramF.valueE -textvariable paramValue -width 45
	pack .dialog.paramF.numeL -side left -padx 2
	pack .dialog.paramF.valueE -side right -padx 2
	button .dialog.buttonsF.okB -text OK -command {set done ok}
	button .dialog.buttonsF.cancelB -text Cancel -command {set done cancel}
	pack .dialog.buttonsF.okB .dialog.buttonsF.cancelB -side left \
	-anchor c -padx 5
	set done not_yet
	grab .dialog
	tkwait variable done
	grab release .dialog
	destroy .dialog

	if {![string compare $done ok]} \
	{
		unset paramM4($pM4)
		set tmp "$paramName $paramValue"
		set paramM4($tmp) $countPM4
		set pM4 "$tmp"

		destroy  $mul4.mup.right.custom.b.bx
		eval tk_optionMenu $mul4.mup.right.custom.b.bx pM4 [lsort [array names paramM4 ]]
		$mul4.mup.right.custom.b.bx configure -width 20
		pack    $mul4.mup.right.custom.b.bx  -side left
	}
}

###################################################################
#------------------------------------------------------------------
#             EditFlow
#------------------------------------------------------------------
###################################################################
proc EditMFlow { action } \
{
   global flowM	  ;# flowM data
   global flowMLB  ;# flowM list(box)
   global modM	  ;# flowM modifier data
   global done	  ;# ok or cancel ?


   if { $action == 0 } \
   {
      set flowNr [$flowMLB curselection]
      if {$flowNr == ""} \
      {
        tk_messageBox -message "Select Flow...!!"
        #nothing selected
        return
      }
      incr flowNr
   } else { 
      set flowNr $action
   }
   set done not_yet

   toplevel .dialog
   wm title .dialog "Edit Flow No. $flowNr"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3
   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
   -anchor n -expand true


   #standard params
   #(relative) flowM start time:
   frame .dialog.fr1.name -bd 2 -relief groove
   pack  .dialog.fr1.name -pady 3 -padx 3 -fill x
   label .dialog.fr1.name.l -text "Flow Name"
   pack  .dialog.fr1.name.l -side top -padx 3
   entry .dialog.fr1.name.e -textvariable flowM(name,$flowNr) -width 30
   pack  .dialog.fr1.name.e -side bottom -padx 3


   frame .dialog.fr1.fstart
   pack  .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "Flow Start (ms)"
   pack  .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable flowM(start,$flowNr)  -width 10
   pack .dialog.fr1.fstart.e -side right -padx 3

   #(relative) flowM stop time
   frame .dialog.fr1.fstop
   pack .dialog.fr1.fstop -pady 3 -fill x
   label .dialog.fr1.fstop.l -text "Flow Stop (ms)"
   pack .dialog.fr1.fstop.l -side left -padx 3
   entry .dialog.fr1.fstop.e -textvariable flowM(stop,$flowNr) \
   -width 10
   pack .dialog.fr1.fstop.e -side right -padx 3

   #an explanation:
   label .dialog.fr1.exp -text "(Relative to test start)"
   pack .dialog.fr1.exp -padx 3 -pady 2

   #port number. This will be verified at last
   #to have only flows with unique port numbers

   frame .dialog.fr1.fport
   pack .dialog.fr1.fport -pady 3 -fill x
   label .dialog.fr1.fport.l -text "Destination Port"
   pack .dialog.fr1.fport.l -side left -padx 3
   entry .dialog.fr1.fport.e -textvariable flowM(port,$flowNr) \
   -width 10
   pack .dialog.fr1.fport.e -side right -padx 3

   #pattern type frame, label and radiobuttons
   frame .dialog.fr1.fpattern
   pack .dialog.fr1.fpattern -pady 3 -fill x
   label .dialog.fr1.fpattern.l -text "Pattern"
   pack .dialog.fr1.fpattern.l -side left -padx 3 -fill x
   frame .dialog.fr1.fpattern.rbF -bd 2 -relief groove
   pack .dialog.fr1.fpattern.rbF -padx 3 -pady 3 -side right
   radiobutton .dialog.fr1.fpattern.rbF.rb1 -text PERIODIC \
   -variable flowM(pattern,$flowNr) -value PERIODIC
   radiobutton .dialog.fr1.fpattern.rbF.rb2 -text POISSON \
   -variable flowM(pattern,$flowNr) -value POISSON
   pack .dialog.fr1.fpattern.rbF.rb1 .dialog.fr1.fpattern.rbF.rb2 \
   -padx 2 -pady 2 -anchor w

   #rate:
   frame .dialog.fr1.frate
   pack .dialog.fr1.frate -pady 3 -fill x
   label .dialog.fr1.frate.l -text "Rate (packets/sec)"
   pack .dialog.fr1.frate.l -side left -padx 3
   entry .dialog.fr1.frate.e -textvariable flowM(rate,$flowNr) \
   -width 10
   pack .dialog.fr1.frate.e -side right -padx 3

   #UDP packet payload size
   frame .dialog.fr1.fsize
   pack .dialog.fr1.fsize -pady 3 -fill x
   label .dialog.fr1.fsize.l -text "Packet Size (bytes)"
   pack .dialog.fr1.fsize.l -side left -padx 3
   entry .dialog.fr1.fsize.e -textvariable flowM(size,$flowNr) \
   -width 10
   pack .dialog.fr1.fsize.e -side right -padx 3

   #frame 2: optional params
   #tos field:

   frame .dialog.fr2.tosF
   pack .dialog.fr2.tosF -pady 3 -fill x -anchor n

   checkbutton .dialog.fr2.tosF.cb -text "Type-of-Service" \
   -variable flowM(tosBool,$flowNr) -command {
   if $flowM(tosBool,$flowNr) {
       .dialog.fr2.tosF.e config -state normal -fg black
       } else {
       .dialog.fr2.tosF.e config -state disabled -fg gray
       }
   }
   pack .dialog.fr2.tosF.cb -side left -padx 3
   entry .dialog.fr2.tosF.e -textvariable flowM(tos,$flowNr) \
   -state disabled -width 10 -fg gray
   pack .dialog.fr2.tosF.e -side right -padx 3


   #RSVP:
   frame .dialog.fr2.rsvp
   pack .dialog.fr2.rsvp -pady 3 -fill x -anchor n
   checkbutton .dialog.fr2.rsvp.cb -text "Use RSVP" \
   -variable flowM(rsvpBool,$flowNr) -command {
   if $flowM(rsvpBool,$flowNr) {
       pack .dialog.fr2.rsvp.params -anchor n -fill x \
       -pady 3 -padx 3
       } else {
       pack forget .dialog.fr2.rsvp.params
       }
   }
   pack .dialog.fr2.rsvp.cb -padx 3 -anchor w

   frame .dialog.fr2.rsvp.params -bd 2 -relief groove
   #no need to pack it :-)

   label .dialog.fr2.rsvp.params.l -text "RSVP Parameters"
   pack .dialog.fr2.rsvp.params.l -padx 3 -pady 3 -anchor c
   entry .dialog.fr2.rsvp.params.e -textvariable flowM(rsvp,$flowNr)
   pack .dialog.fr2.rsvp.params.e -fill x -padx 3 -pady 3

   frame .dialog.fr2.rsvp.params.style
   pack .dialog.fr2.rsvp.params.style -fill x
   label .dialog.fr2.rsvp.params.style.l -text "RESV Style"
   pack .dialog.fr2.rsvp.params.style.l -side left -padx 3

   frame .dialog.fr2.rsvp.params.style.rbF -bd 2 -relief groove
   pack .dialog.fr2.rsvp.params.style.rbF -padx 3 -pady 3

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb1 \
   -text "WF (Wildcard)" -variable flowM(style,$flowNr) -value WF

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb2 \
   -text "FF (Fixed-Filter)" -variable flowM(style,$flowNr) -value FF

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb3 \
   -text "SE (Shared-Explicit)" -variable flowM(style,$flowNr) -value SE

   pack .dialog.fr2.rsvp.params.style.rbF.rb1 \
   .dialog.fr2.rsvp.params.style.rbF.rb2 \
   .dialog.fr2.rsvp.params.style.rbF.rb3 -pady 3 -padx 3 -anchor w


   label .dialog.fr2.rsvp.params.lr -text "RESV Parameters"
   pack .dialog.fr2.rsvp.params.lr -padx 3 -pady 3 -anchor c
   entry .dialog.fr2.rsvp.params.er -textvariable flowM(resv,$flowNr)
   pack .dialog.fr2.rsvp.params.er -fill x -padx 3 -pady 3

   #ok-cancel buttons on 3rd frame

   button .dialog.fr3.ok -text OK -command {
   set done ok
   destroy .dialog
   } -width 6

   button .dialog.fr3.cancel -text Cancel -command {
   set done cancel
   destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
   -padx 3 -pady 3

   grab .dialog
   tkwait window .dialog

   #cancel was pressed
   if ![string compare $done cancel] { return  }

   #ok was pressed:
   #first verify that standard parameters are filled
   foreach elem {start stop port rate size} \
   {
      if ![string compare $flowM($elem,$flowNr) ""] \
      {
         tk_messageBox -message "Missing Flow parameteres...!!"
         EditFlow $flowNr 
         return
      }
   }

   #check port; must be unique for each flow
   for {set i 1} {$i <= $flowM(number)} {incr i} \
   {
      if { $flowM(port,$flowNr) == $flowM(port,$i)  && $flowNr != $i }  \
      {
         tk_messageBox -message "Port value already used on flow $i"
         EditFlow $flowNr 
         return
      }
   }
   $flowMLB delete [expr $flowNr - 1]
   $flowMLB insert [expr $flowNr - 1]  \
   [format "Flow  %02d   -   Mods  %02d  -  %s" \
   $flowNr $modM(number,$flowNr) $flowM(name,$flowNr) ]
}
